#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=arpfreeze.ico
#AutoIt3Wrapper_Compression=4
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;ARPFreeze code by Irongeek from Irongeek.com. Consider it GPL.
#include <Constants.au3>
#include <Array.au3>
#include <iNet.au3>
#include <file.au3>
Local $RawARPTable, $ARPTableArray, $i, $response, $Batchfh, $Logfh, $TheCommand, $CommandOutput
Global $UseVistaNetshWorkaround = 0
Global $MACOUIs
Global $InterfaceIdx
If Not _FileReadToArray("nmap-mac-prefixes", $MACOUIs) Then
	MsgBox(4096, "Error", " Error reading OUIs into Array     error:" & @error)
	Exit
EndIf
Dim Const $ver = "ARPFreeze 0.01 from Irongeek.com"
;MsgBox(0, "ARPFreeze", " ARPFreeze is a tool from Irongeek.com that makes making static ARP tables a little easier. This can help somewhat in protecting against ARP Poisoning. ")

$RawARPTable = GetARPTable()
$ARPTableArray = LoadARPArray($RawARPTable)

If FileExists("arpstaticscript.bat") Then
	$response = MsgBox(4, $ver, "Arpstaticscript.bat already exists. Do you wish to append to it? Click YES to append new static entries, or NO to delete the current arpstaticscript.bat and start a new one.")
	If $response = 7 Then
		FileDelete("arpstaticscript.bat")
	EndIf
EndIf
$Batchfh = FileOpen("arpstaticscript.bat", 1)
$Logfh = FileOpen("arpfreezelog.txt", 1)

$response = MsgBox(260, $ver, "Do you wish to use the Vista Netsh workaround instead of arp -s?")
If $response = 6 Then
	$TheCommand = "netsh interface ip show interfaces"
	$foo = Run($TheCommand, "", @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)
	While 1
		$CommandOutput = $CommandOutput & StdoutRead($foo) & StderrRead($foo)
		If @error Then ExitLoop
	WEnd
	$InterfaceIdx = InputBox("", $CommandOutput & @CRLF & "Type in the Idx of the interface you wish to set", 10, "", 400, 400)
	$UseVistaNetshWorkaround = 1
EndIf



For $i = 0 To UBound($ARPTableArray) - 1
	$response = MsgBox(4, $ver, "Do you wish to make " & @CRLF & @CRLF & $ARPTableArray[$i][0] & " (" & HostDescription($ARPTableArray[$i][0]) & ")" & @CRLF & "                 to " & @CRLF & $ARPTableArray[$i][1] & " (" & MACLookup($ARPTableArray[$i][1]) & ")" & @CRLF & @CRLF & "static?")
	If $response = 6 Then
		If $UseVistaNetshWorkaround Then
			$TheCommand = "netsh -c ""interface ipv4"" set neighbors " & $InterfaceIdx & " """ & $ARPTableArray[$i][0] & """ """ & $ARPTableArray[$i][1] & """"
			;msgbox(0,"",$TheCommand)
		Else
			$TheCommand = "arp -s " & $ARPTableArray[$i][0] & " " & $ARPTableArray[$i][1]
		EndIf
		$foo = Run($TheCommand, "", @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)
		FileWriteLine($Batchfh, $TheCommand & " 1>> arpfreezelog.txt 2>&1")
		While 1
			$CommandOutput = $CommandOutput & StdoutRead($foo) & StderrRead($foo)
			If @error Then ExitLoop
		WEnd
		FileWriteLine($Logfh, $TheCommand & ":" & $CommandOutput)
	EndIf
Next

$response = MsgBox(4, $ver, "Schedule " & @WorkingDir & "\Arpstaticscript.bat to run on every system boot?")

If $response = 6 Then
	$TheCommand = "schtasks /create /tn SetStaticArp /tr ""\""" & @WorkingDir & "\arpstaticscript.bat""\"" /sc ONSTART /ru system"
	Run("schtasks /delete /TN SetStaticArp /f", "", @SW_HIDE)
	MsgBox(0, $ver, "This is the command I'm about to run to schedule the task:" & @CRLF & $TheCommand)
	$foo = Run($TheCommand, "", @SW_HIDE)
EndIf


MsgBox(0, $ver, "Done. These settings should last until the next reboot(unlesss you used the schedule on boot option). Depending on when interfaces become available, you may have to rerun the arpstaticscript.bat script after logon. Also, Vista sometimes denies permission to some ARP entries until reboot unless you use the Netsh workaround.")

;-------------------------------------------------------Functions Below-----------------------------------------------------------------------------
Func HostDescription($input)
	Local $results
	If $input = IP_Gateway_List() Then
		$results = "This is the IP gateway!!!"
	Else
		$results = _TCPIpToName($input)
	EndIf
	If $results = "" Then $results = "No rDNS"
	Return $results
EndFunc   ;==>HostDescription

Func MACLookup($input)
	$input = StringReplace(StringLeft($input, 8), "-", "")
	$iIndex = _ArraySearch($MACOUIs, $input, 0, 0, 0, 1)
	If @error Then Return "unknown"
	;Msgbox(0,'Record:', $MACOUIs[$iIndex])
	Return StringRight($MACOUIs[$iIndex], StringLen($MACOUIs[$iIndex]) - 7)
EndFunc   ;==>MACLookup

Func GetARPTable()
	Local $foo, $line, $output
	;@ComSpec & " /c " &
	$foo = Run("arp -a", @SystemDir, @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)
	;ProcessWait("arp.exe", 30)
	;ConsoleWrite($foo & crlf )
	While 1
		$line = StdoutRead($foo)
		If @error Then ExitLoop
		$output = $output & $line
	WEnd
	StdioClose($foo)
	Return $output
EndFunc   ;==>GetARPTable

Func LoadARPArray($input)
	$tmpARPArray1 = StringSplit($input, @CRLF)
	$tmpARPStr = ""
	For $line In $tmpARPArray1
		If StringLen($line) = 56 Then
			$tmpARPStr = $tmpARPStr & $line
		EndIf
	Next
	$tmpARPStr = StringReplace($tmpARPStr, 'dynamic', "")
	$tmpARPStr = StringReplace($tmpARPStr, 'invalid', "")
	$tmpARPStr = StringReplace($tmpARPStr, 'static', "")
	$tmpARPStr = StringStripWS(StringStripWS(StringStripWS($tmpARPStr, 4), 1), 2)
	$1DimArpArray = StringSplit($tmpARPStr, ' ')
	If @error = 1 Then Return
	Local $2DimArpArray[($1DimArpArray[0] / 2)][2]
	Local $i = 1
	Local $j = 0
	While $i < $1DimArpArray[0]
		$2DimArpArray[$j][0] = $1DimArpArray[$i]
		$2DimArpArray[$j][1] = $1DimArpArray[$i + 1]
		$i += 2
		$j += 1
	WEnd
	_ArraySort($2DimArpArray, 0)
	;_ArrayDisplay($2DimArpArray)
	Return $2DimArpArray
EndFunc   ;==>LoadARPArray

Func IP_Gateway_List()
	Local $output = ""
	Local $wbemFlagReturnImmediately = 0x10
	Local $wbemFlagForwardOnly = 0x20
	Local $colItems = ""
	Local $objWMIService = ObjGet("winmgmts:\\localhost\root\CIMV2")
	Local $colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapterConfiguration", "WQL", $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	If IsObj($colItems) Then
		For $objItem In $colItems
			$output &= " " & $objItem.DefaultIPGateway(0)
		Next
	Else
		MsgBox(0, "WMI Error", "No Gateways found.")
	EndIf
	Return StringStripWS($output, 3)
EndFunc   ;==>IP_Gateway_List
